'use strict';
function App() {
    Vue.config.proto = false;

    Vue.component('app-window', { template: '#app-window', replace: true });
    // Vue.component('app-input',  { template: '#app-input' });

    var Resizing = false;
    var Autoscroll = false;
    var resizeTime = 100;
    var settleScrollTime = 100;
    var pollHeightTime = 500;
    var reconnectTime = 1000;
    var reconnectTimeMax = reconnectTime * 15;

    var Connected = false;
    var Wsconn;

    var debugOut = [ { content: 'type websocket address and password to connect' } ];
    var someLines = {
	b: [
		{ content: 'place<span>&lt;</span>holder' }
	]
    };
    var someWindows = {
	a: { id: 0, height: '50%', bottom: true, topic: 'Debug window', lines: debugOut },
	b: { id: 1, height: '50%', bottom: true, topic: '', lines: someLines.b }
    };

    function ensureWindowBottom(win) {
    	if (win.bottom) {
	    if (!Autoscroll) {
		Autoscroll = true;
		// time to settle scroll
		setTimeout(function() { Autoscroll = false; }, settleScrollTime);
	    }
    	    win.$$.view.querySelector('.end-of-view').scrollIntoView();
    	}
    }

    function isViewBottom(view) {
	var eov = view.querySelector('.end-of-view');
	////debug code:
	//console.log(view);console.log(eov);console.log("[ "+eov.offsetTop+" / "+(view.scrollTop + view.clientHeight)+" ]");
	return eov.offsetTop <= view.scrollTop + view.clientHeight + view.offsetTop + 1;
    }

    function getInitialLines(ws, viewid) {
	var get_view = {};
	var sub_add = {view:viewid};
	sub_add[viewid] = {text:true};
	get_view[viewid] = {text:true,lv:0};
	return ws.sendp({
	    line:{
		get:get_view,
		sub_add:{
		    add:sub_add,
		    alter:sub_add
		}
	    }
	}).then(function(res) {
	    var lines = res.msg.line.get;
	    var view;
	    for (view in lines) {
		lines[view].forEach(function(line) {
		    line.content = Irssi.toHtml(line.text);
		});
		Model.window[ Model.view[view] ].lines = lines[view];
	    }
	    console.log(Model);
	});
    }

    var Model = {};

    function updateModel(container, msg, by) {
	var obj = container[msg[by]];
	var k;
	for (k in msg) {
	    obj[k] = msg[k];
	}
	return obj;
    }

    var vm = new Vue({
	el: '#app',
	events: {
	    'ws error': function(x) {
		this.addLine(debugOut, {content:"error:"+x+", connected="+Connected});
	    },
	    'ws closed': function(x) {
		this.addLine(debugOut, {content:"closed:"+x+", connected="+Connected});
		if (Connected || this.reconnecting) {
		    var self = this;
		    setTimeout(self._connect.bind(self), reconnectTime + (reconnectTime * this.reconnecting) % reconnectTimeMax);
		    this.reconnecting++;
		}
		Connected = false;
	    },
	    connected: function() {
		var self = this;
		Wsconn.sendp({
		    window:{
			get:{lv:1},
			sub:{
			    ex:{lv:1},
			    attr:{},
			    act:{}
			}
		    },
		    item:{
			get:{lv:1}
		    }
		}).then(function(res) {
		    var wininfo = res.msg.window.get;
		    Model.window = {};
		    Model.view = {};
		    Model.item = {};
		    self.actlist = wininfo.filter(function(window) { return window.data_level > 0; });
		    wininfo.forEach(function(window) {
			Model.window[window.id] = window;
			Model.view[window.view] = window.id;
		    });
		    res.msg.item.get.forEach(function(item) {
			Model.item[item.id] = item;
		    });
		    Model.winlist = wininfo.map(function(window) { return window.id; });
		    var active = wininfo.filter(function(window) { return window.active_win; });
		    Model.active_win = active[0].id;
		    getInitialLines(res.ws, active[0].view).then(function() {
			var dummy = self.windows.indexOf(someWindows.b);
			if (dummy !== -1) { self.windows.splice(dummy, 1); }
			var win = Model.window[ active[0].id ];
			self.mapWindow(win);
		    });
		});
	    },
	    'line added': function(lines) {
		var self = this;
		for (var view in lines) {
		    lines[view].forEach(function(line) {
			line.content = Irssi.toHtml(line.text);
			Model.window[ Model.view[view] ].lines.push(line);
			self.ensureLinesBottom(Model.window[ Model.view[view] ].lines);
		    });
		}
	    },
	    reconnected: function() {
	    },
	    'window activity': function(msg) {
		var self = this;
		console.log("got activity");
		updateModel(Model.window, msg, 'id');
		self.actlist = Model.winlist.map(function(id) { return Model.window[id]; })
		    .filter(function(window) { return window.data_level > 0; });
		console.log(self.actlist);
	    }
	},
	data: {
	    reconnecting: 0,
	    activeWin: "a",
	    windows: [ someWindows.a, someWindows.b ],
	    actlist: [],
	    input: 'wss://[::1]:9002/teddy '
	},
	methods: {
	    addLine: function(lines, line) {
		lines.push(line);
		this.ensureLinesBottom(lines);
	    },
	    mapWindow: function(win) {
		var self = this;
		if (self.windows.indexOf(win) === -1) {
		    win.bottom = true;
		    win.height = '50%';
		    win.topic=(win.active?Model.item[win.active]:{}||{}).topic || '';
		    self.windows.push(win);
		}
		Vue.nextTick(function(){self.ensureLinesBottom(win.lines);});
	    },		
	    ensureLinesBottom: function(lines) {
		var wins = this.$.awins.filter(function (win) { return win.lines === lines; });
		Vue.nextTick(function() { wins.forEach(ensureWindowBottom); });
	    },
	    submitInput: function() {
		var self = this;
		if (Wsconn && Wsconn.socket) {
		    if (/^\/raw /.test(this.input)) {
			Wsconn.sendj(eval("(function(){ return "+
					  this.input.replace(/^\/raw /, '')+
					  "\n})()"));
		    } else if (/^\/tw /.test(this.input)) {
			var res = this.input.match(/^\/tw map (\d+)$/);
			if (res) {
			    (function(){
				var winid = Model.winlist.filter(function(id) { return Model.window[id].refnum == res[1]; });
				if (!winid.length) { return; }
				var win = Model.window[winid[0]];
				if (!win.lines) {
				    getInitialLines(Wsconn, win.view).then(self.mapWindow.bind(self, win));
				} else {
				    self.mapWindow(win);
				}
			    })();
			}
			res = this.input.match(/^\/tw unmap (\d+)$/);
			if (res) {
			    (function(){
				var winid = Model.winlist.filter(function(id) { return Model.window[id].refnum == res[1]; });
				if (!winid.length) { return; }
				var win = Model.window[winid[0]];
				var dummy = self.windows.indexOf(win);
				if (dummy !== -1) { self.windows.splice(dummy, 1); }
			    })();
			}
			if ((res = this.input.match(/^\/tw width (\d+) (\d+|auto)$/))) {
			    (function(){
				var winid = Model.winlist.filter(function(id) { return Model.window[id].refnum == res[1]; });
				if (!winid.length) { return; }
				var win = Model.window[winid[0]];
				if (res[2] === 'auto') { win.$delete('width'); }
				else { if (win.width !== undefined) { win.width = res[2] + '%'; }
				       else { win.$add('width', res[2] + '%');  } }
			    })();
			}
			if ((res = this.input.match(/^\/tw height (\d+) (\d+|auto)$/))) {
			    (function(){
				var winid = Model.winlist.filter(function(id) { return Model.window[id].refnum == res[1]; });
				if (!winid.length) { return; }
				var win = Model.window[winid[0]];
				if (res[2] === 'auto') { win.$delete('height'); }
				else { if (win.height !== undefined) { win.height = res[2] + '%'; }
				       else { win.$add('height', res[2] + '%');  } }
			    })();
			}
		    } else {
			Wsconn.sendj({input:{data:this.input}});
		    }
		} else {
		    var x = this.input.split(' ');
		    this.connect(x[0], x[1]);
		}
		return false;
	    },
	    clearInput: function() {
		this.input = '';
		return false;
	    },
	    _connect: function() {
		var self = this;
		var key;
		Wsconn.connect().then(function(ok) {
                    key = Math.random().toString(36).substr(2);
		    return ok.ws.sendp({ challenge : key });
		}).then(function(ok) {
		    return ok.ws.sendp(
                            { login: CryptoJS
                              .HmacSHA256(self._password(), ok.msg.challenge + key)
                              .toString(CryptoJS.enc.Base64).replace(/=$/,'') });
		}).then(function(ok) {
		    Connected = true;
		    if (self.reconnecting) {
			self.reconnecting = 0;
			self.$emit('reconnected');
		    } else {
			self.$emit('connected');
		    }
		}).catch(function(err) {
		    self.addLine(debugOut, {content:"error:"+err});
		});	
	    },
	    connect: function(url, password) {
		var self = this;
		self.addLine(debugOut, {content:"connecting"});
		this._password = function() { return password; };
		//Wsconn = new SocketP(url, this.$emit.bind(self));
		Wsconn = new SocketP(url, self.$emit.bind(self),
				     function(dir, msg) { //debugger
					 if (msg !== '{}') {
					     self.addLine(debugOut, {content:dir+" "+msg});
					 }
				     });
		self._connect();
	    },
	    viewManualScroll: (function(){
		var timer = null;
		return function(proxy, event) {
		    // last scroll may have been a resize
		    if (timer) { clearTimeout(timer); timer = null; }
		    if (Autoscroll || Resizing) { return; }
		    timer = setTimeout(function(){
			proxy.bottom = isViewBottom(proxy.$$.view);
		    }, 80);
		};
	    })()
	}
    });
    //// polling is unavoidable for delayed content loading
    // setInterval(function() {
    // 	vm.$.awins.forEach(function(win) {
    // 	    var view = win.$$.view;
    // 	    var newScrollHeight = view.scrollHeight;
    // 	    if (win._scrollHeight !== newScrollHeight) {
    // 		if (win.bottom) {
    // 		    view.querySelector('.end-of-view').scrollIntoView();
    // 		}
    // 		win._scrollHeight = newScrollHeight;
    // 	    }
    // 	});
    // }, pollHeightTime);
    window.onresize = (function() {
    	var timer = null;
    	return function() {
    	    Resizing = true;
    	    if (timer) { clearTimeout(timer); timer = null; }
    	    timer = setTimeout(function(){
    		vm.$.awins.forEach(ensureWindowBottom);
		// see if any window is newly stuck to bottom
		setTimeout(function(){
		    vm.$.awins
			.filter(function(win) { return !win.bottom; })
			.forEach(function(win){
			    win.bottom = isViewBottom(win.$$.view);
			});
		}, settleScrollTime);
    		Resizing = false;
    	    }, resizeTime);
    	};
    })();
    document.forms.data.input.focus();
}
