var wsconn;
var tchist = [];
var histid = -1;
var checkjson;

function loadCons() {
    console.log("now loaded");
}

function sendMsg(event) {
    var input = document.getElementsByTagName('textarea')[0];
    var r = document.getElementById('response');
    var value;
    if (checkjson !== undefined) { window.clearTimeout(checkjson); checkjson = undefined; }
    if (event.keyCode === 13) {
	value = input.value;
	if (wsconn === undefined) {
	    var x = value.split(' ');
	    try {
		wsconn = new WebSocket(x[0]);
	    } catch (e) {
		var html = e.replace(/</g, '&lt;');
		r.insertAdjacentHTML('afterbegin', '<li class="error">'+html+'</li>');
		wsconn = undefined;
	    }
	    if (wsconn) {
		r.insertAdjacentHTML('afterbegin', '<li class="connecting">connecting</li>');
		wsconn.onmessage = function(event) {
		    if (wsconn.authnow && event.data.indexOf('challenge') !== -1) {
			wsconn.authnow(JSON.parse(event.data));
			r.insertAdjacentHTML('afterbegin', '<li class="login">login</li>');
			delete wsconn.authnow;
		    } else {
			var html = event.data.replace(/</g, '&lt;');
			if (html === '{}') {
			    var elem = r.querySelector('.ping');
			    if (elem && elem.parentElement) {
				elem.parentElement.removeChild(elem);
			    }
			    r.insertAdjacentHTML('afterbegin', '<li class="ping">'+html+' '+(new Date())+'</li>');
			} else {
			    r.insertAdjacentHTML('afterbegin', '<li>'+html+'</li>');
			}
		    }
		};
		wsconn.onerror = function(event) {
		    var html = JSON.stringify(event).replace(/</g, '&lt;');
		    r.insertAdjacentHTML('afterbegin', '<li class="error">'+(event.message ? event.message : event.type)+'</li>');
		    wsconn = undefined;
		};
		wsconn.onclose = function(event) {
		    var value = input.value;
		    r.insertAdjacentHTML('afterbegin', '<li class="closed">'+(event.reason ? event.reason : event.type)+'</li>');
		    wsconn = undefined;
		    if (histid > -1 && histid < tchist.length && tchist[histid] === value) {}
		    else if (value !== '') { tchist.push(value); }
		    input.value = x[0] + ' ';
		};
		wsconn.onopen = function(event) {
                    var key = Math.random().toString(36).substr(2);
                    wsconn.send(JSON.stringify(
			{ challenge: key }
                    ));
		    wsconn.authnow = function(msg) {
			wsconn.send(JSON.stringify(
                            { login: CryptoJS
                              .HmacSHA256(x[1], msg.challenge + key)
                              .toString(CryptoJS.enc.Base64).replace(/=$/,'') }
			));
		    };
		};
	    }
	}
	else {
	    wsconn.send(value);
	    if (histid > -1 && histid < tchist.length && tchist[histid] === value) {}
	    else if (value !== '') { tchist.push(value); }
	    histid = -1;
	    r.insertAdjacentHTML('afterbegin', '<li class="outgoing">'+value.replace(/</g, '&lt;')+'</li>');
	}
	input.value = '';
	event.preventDefault();
	return true;
    } else if (event.keyCode === 38) { // up
	value = input.value;
	if (histid > -1 && histid < tchist.length && tchist[histid] === value) {}
	else if (value !== '') { tchist.push(value); }
	histid--; if (histid < -1) { histid = tchist.length ? tchist.length - 1 : -1; }
	if (histid == -1) { input.value = ''; }
	else { input.value = tchist[histid]; }
	return true;
    } else if (event.keyCode === 40) { // down
	value = input.value;
	if (histid > -1 && histid < tchist.length && tchist[histid] === value) {}
	else if (value !== '') { tchist.push(value); }
	histid++; if (histid >= tchist.length) { histid = -1; }
	if (histid == -1) { input.value = ''; }
	else { input.value = tchist[histid]; }
	return true;
    }
    if (wsconn && input.value !== '') {
	checkjson = window.setTimeout(function() {
	    try {
		JSON.parse(input.value);
		input.classList.add("valid");
	    } catch (e) {
		input.classList.remove("valid");
	    }
	}, 200);
    }
    
    return false;
}
